#!/usr/bin/env python
#
# $Id: commands.py 3979 2008-12-22 11:35:16Z ltsai $
#
# Copyright 2007 Platform Computing Inc.
#

import os
import sys
import shutil
import atexit
from primitive.core.command import Command
from primitive.core.command import CommandFailException
from path import path
from you import YouUpdate

class UpdateCommand(Command):

    def __init__(self, **kwargs):
        Command.__init__(self, 
                         name='updatetool', 
                         logged=True, 
                         locked=True, 
                         lockdir=os.getenv('PRIMITIVE_LOCKDIR', '/var/lock/subsys/primitive'))

class YouUpdateCommand(UpdateCommand):

    def __init__(self, **kwargs):
        UpdateCommand.__init__(self, **kwargs)

        try:
            self.username = kwargs['username']
            self.password = kwargs['password']
            self.channel = kwargs['channel']
            self.arch = kwargs['arch']
            self.repopath = kwargs['repopath']

        except KeyError:
            raise CommandFailException,'required key not supplied'
 
    def execImpl(self):
        youu = YouUpdate(username = self.username, password = self.password,
                         channel = self.channel, 
                         arch = self.arch)
        return youu.getUpdates(self.repopath)
           
